#define F_CPU 12000000UL // บอกไลบรารีว่า MCU ทำงานที่ 12MHz
#include <avr/io.h>
#include <util/delay.h>

//PC0 = LED1
//PC1 = LED2
//PC2 = LED3
//PC3 = switch1
//PC4 = switch2
//PC5 = swirch3

//PB0 = Gled1
//PB3 = Gled2
//PB4 = Gled3
//PB5 = Gled4

void life()
{
	if(PINB == 0b00111001) PORTB=0b00111000;
	else if (PINB == 0b00111000) PORTB=0b00110000;
	else if (PINB == 0b00110000) PORTB=0b00100000;	
	else if (PINB == 0b00100000) PORTB=0b00000000;
}

void ending()
{
	while(1)
	{
		PORTC= 0b00000001;
		_delay_ms(500);
		PORTC= 0b00000010;
		_delay_ms(500);
		PORTC= 0b00000100;
		_delay_ms(500);
		PORTC= 0b00000111;
		_delay_ms(500);
		PORTC= 0b00000011;
		_delay_ms(500);
		PORTC= 0b00000101;
		_delay_ms(500);
		PORTC= 0b00000110;
		_delay_ms(500);
		PORTC= 0b00000010;
		_delay_ms(500);
		PORTC= 0b00000101;
		_delay_ms(500);
		PORTC= 0b00000010;
		_delay_ms(500);
		PORTC= 0b00000101;
		_delay_ms(500);
		PORTC= 0b00000011;
		_delay_ms(500);
		PORTC= 0b00000110;
		_delay_ms(500);
		PORTC= 0b00000111;
		_delay_ms(500);
		PORTB = 0b000111001;
		break;
	}
}

int power(int x,int y){
if(y==0)
	return 1;
return x*power(x,y-1);

}
main(){
	int time =2;
	int check=0;
	int max=200;
	int y=2;
	int i=3;
	int start ;
	int x;
	PORTD = 0b11100000;  // กำหนดลอจิกขา PD7..0 เป็น 0
	DDRD  = 0b11100000;  // กำหนดให้ขา PD3 ทำหน้าที่เอาท์พุท
	DDRC  = 0b00000111;
	PORTC = 0b00111000;
	DDRB  = 0b111111111;
	PORTB = 0b000111001; 	
    while (1)
    {
	if(!(PINC&0b00010000))
	{
	start =1;
	max =200;
	PORTC = 0b00111111;
	_delay_ms(800);
	while(start){
	time=max;
	i++;
	y = (power(17,i)+y)%3;
	if(y==0){
		PORTC = 0b00111001;
		while (1)
		{	
			if(time==0){
				break;
			}
			else 
			{
				_delay_ms(10);
			}
			if(!(PINC&0b00001000))
		        { 
				check = 1;
				break;
               		//	 PORTC |= 0b00000010;
      			 }
			if(!(PINC&0b00010000)||(!(PINC&0b00100000))||(!(PINC&0b00110000)))
			{
				break;
			}
			time--;
		}
		if(check==0)
			life();
		PORTC = 0b00000000;
		_delay_ms(100);

	}

	if(y==1){
		PORTC = 0b00111010;
                while(1)
                {
			if(time==0){
				break;
			}
			else
			{
				_delay_ms(10);
			}
                        if(!(PINC&0b00010000))
			{
                                check = 1; 
                                break;
			}
                        //       PORTC |= 0b00000010;
                         
                        if(!(PINC&0b00001000)||(!(PINC&0b00100000))||(!(PINC&0b00101000)))
                        {
                                break;
                        }
			time--;
                }
                if(check==0)
                        life();
		PORTC = 0b00000000;
                _delay_ms(100);
	}
	
	if(y==2){ PORTC = 0b00111100;
		while(1)
                {	 
			if(time==0){
				break;			
			}
			else
			{
				_delay_ms(10);
			}
                        if(!(PINC&0b00100000))
                        {
                                        check=1;
                                        break;
                        //       PORTC |= 0b00000010;
                         }
                        if(!(PINC&0b00010000)||(!(PINC&0b000001000))||(!(PINC&0b00011000)))
                        {
                                break;
                        }
			time--;
                }
                if(check==0)
                        life(); 
		PORTC = 0b00000000;
                _delay_ms(100);
	}
	PORTC = 0b00111000;
	if(PINB == 0b00000000)
	{
		ending();
		start =0;
		break;
		}
	if(time>50 & check==1)
		max-=10;
	check=0;	
	_delay_ms(100);
	}
    }
	}
}
 
